import sys
#sys.path.insert(0, "/usr/lib/python2.5/site-packages/orange1/")

import orange, orngDicty, numpy, orngMDS, random, mOrngData
import stats
import mMisc as m
#import pylab

addressS = "http://purple.bioch.bcm.tmc.edu/~anup/index.php?token=gFl0g7y5lefcnY6mqAdLd&"

def getBasicData():

    dbc = m.autoPck("tmpdbc1_1.pck", "3", orngDicty.DatabaseConnection, addressS)
    #dbc = DatabaseConnection(addressS)
    read = m.autoPck("tmp_minichip_1.pck", "1", dbc.selectN, platform='minichip')
    #read = dbc.selectN( platform='minichip')
    #print dbc.createExampleTables(read, allowDiff=["timePoint","techReplicate"])
    etso = dbc.createExampleTables(read, allowDiff=["timePoint"], ignore=[".*"], ignoreNot=["techReplicate", "sample" ] )

    ets = [ orngDicty.averageAttributes(e) for e in etso ]
    
    for i in range(len(ets)):
        ets[i].annot = etso[i].annot
        trepl, smpl = ets[i].annot["techReplicate"][0], ets[i].annot["sample"][0]
        ets[i].save("n_av_sample_%s_trepl_%s.tab" % (smpl, trepl))

    return ets


def testConversion():
    dbc = m.autoPck("tmpdbc1_1_16mut.pck", "4", orngDicty.DatabaseConnection, addressS)
    read = m.autoPck("tmp_minichip_1_16mut.pck", "2", dbc.selectN, platform='minichip')
    etso = dbc.createExampleTables(read, allowDiff=["timePoint"], ignore=[".*"], ignoreNot=["techReplicate", "sample" ] )


#testConversion()
#import sys; sys.exit(0)



def getBasicData2():

    dbc = m.autoPck("tmpdbc1_1_16mut.pck", "4", orngDicty.DatabaseConnection, addressS)
    #dbc = DatabaseConnection(addressS)
    read = m.autoPck("tmp_minichip_1_16mut.pck", "2", dbc.selectN, platform='minichip')

    #read = dbc.selectN( platform='minichip')
    #print dbc.createExampleTables(read, allowDiff=["timePoint","techReplicate"])
    etso = dbc.createExampleTables(read, allowDiff=["timePoint"], ignore=[".*"], ignoreNot=["techReplicate", "sample" ] )

    #to get A5 sample
    etso2 = dbc.createExampleTables(read, allowDiff=["timePoint"], ignore=[".*"], ignoreNot=["replicate" , "techReplicate", "sample" ] )

    etsoA5 = []
    for et in etso2:
        if et.annot["sample"][0] == "abcA5-":
            etsoA5.append(et)

    ets = []

    for et in etso + etsoA5:
        new = orngDicty.averageAttributes(et)
        new.annot = et.annot
        trepl, smpl, repl = et.annot["techReplicate"][0], et.annot["sample"][0], min(et.annot["replicate"])

        if smpl == "abcA5-":
            print "A5"
            print new.domain.attributes
            if len(new.domain.attributes) > 4:
                print "skipped"
                continue # skip those with more attributes

        print len(et), len(new)

        new.save("n216_av_sample_%s_trepl_%s_repl_%s.tab" % (smpl, trepl, repl))
        ets.append(new)

    return ets

def getBasicDataSeparatedPck(ver):
    if ver == 1:
        return m.autoPck("bds.pck", "1", getBasicDataSeparated)
    if ver == 2:
        return m.autoPck("bds_v2.pck", "5", getBasicDataSeparated2)


def getBasicDataPck(ver):
    if ver == 1:
        return m.autoPck("bd.pck", "1", getBasicData)
    if ver == 2:
        return m.autoPck("bd_v2.pck", "4", getBasicData2)


def getBasicDataSeparated():
    #dont join times to one example table

    _,dbc = m.autoPickler("tmpdbc1_1.pck", "3", orngDicty.DatabaseConnection, addressS)
    _,read = m.autoPickler("tmp_minichip_1.pck", "2", dbc.selectN, platform='minichip')
    etso = dbc.createExampleTables(read, allowDiff=[], ignore=[".*"], ignoreNot=["techReplicate", "sample", "timePoint","replicate" ] )

    ets = [ orngDicty.averageAttributes(e) for e in etso ]
    
    for i in range(len(ets)):
        a = ets[i].annot = etso[i].annot

    return ets

def getBasicDataSeparated2():
    #dont join times to one example table

    _,dbc = m.autoPickler("tmpdbc1_1_v2.pck", "4", orngDicty.DatabaseConnection, addressS)
    _,read = m.autoPickler("tmp_minichip_1_v2.pck", "3", dbc.selectN, platform='minichip')
    etso = dbc.createExampleTables(read, allowDiff=[], ignore=[".*"], ignoreNot=["techReplicate", "sample", "timePoint","replicate" ] )

    ets = [ orngDicty.averageAttributes(e) for e in etso ]
    
    for i in range(len(ets)):
        a = ets[i].annot = etso[i].annot

    return ets


def attributesConc(data, neednatts=4):
    """
    Joins expression in different times to one another
    as concanating two lists.
    """
    natts = len(data.domain.attributes)

    #trepl, smpl = data.annot["techReplicate"][0], data.annot["sample"][0]
    #print len(data.domain.attributes), trepl, smpl

    if natts != neednatts:
        print natts, data.annot 
        return None

    all = []
    genes = []
    for ex in data:

        def nativeOrNone(val):
            if val.isSpecial():
                return None
            else:
                return val.native()

        all.append([ nativeOrNone(ex[a]) for a in range(natts) ])
        genes.append(str(ex["DDB"]))

    ga = []
    new = []
    for a in range(len(all[0])):
        new = new + m.nth(all,a)
        ga = ga + genes

    return new, ga

def etsToLists(ets, **kwargs):
    """
    Convert example tables to list of lists. Output numpy table and legend.
    """
    
    ll = []
    legend = []

    genes = None

    for et in ets:
        
        try:
            vals, genes1 = attributesConc(et, **kwargs)
        except:
            continue

        if genes:
            if genes != genes1:
                #print genes, len(genes)
                #print len(genes), len(genes1), (set(genes1) - set(genes)),(set(genes) - set(genes1))
                a = aaaaa
        genes = genes1

        annot = (et.annot["techReplicate"][0], et.annot["sample"][0], et.annot["timePoint"][0])
        #print annot
        ll.append(vals)
        legend.append(annot)

    return ll, legend, genes

def listsToNumpy(ll):

    for l in ll:
        print len(l)

    singles = [ numpy.array(l) for l in ll ]
    return numpy.vstack(singles) 

def pearsonCorr(ll):

    numl = listsToNumpy(ll)
    corrs = numpy.corrcoef(numl)
    
    ms = corrs.shape[0]
    distance = orange.SymMatrix(ms)

    for i in range(ms-1):
        for j in range(i+1, ms):
            distance[i, j] = 1-abs(corrs[i,j])

    return distance

def MDS(distance, runs=1000):
    mds = orngMDS.MDS(distance)
    mds.run(runs)
    return mds

def replicatesGraph(points):
    """
    Points is a tuple of (x,y,type). Different types are
    differently colored. One replicate from each sample group
    gets a label "type". 
    """

    allSamples = sorted(m.nth(points, -1))

    pcolors = [ 'red', 'yellow', 'blue', 'violet', 'navy', 'orange', 'gray', 'cyan', "white", "pink", "black", "tan", "brown" ]

    markers = reduce(lambda x,y: x+y, [ [ (ma,c) for c in pcolors ] for ma in [ "o", "s", "d", "^", "v"] ])
    print markers
    print zip(allSamples, markers)

    colors = dict( zip(sorted(set(allSamples)), markers) )

    print colors

    import pylab

    print "All samples", allSamples
    for samp in allSamples:
        sel = filter(lambda x: x[-1]==samp, points) 
        x = m.nth(sel,0) 
        y = m.nth(sel,1)
        pylab.scatter(x, y, c=colors[samp][1], marker=colors[samp][0], s=100)
        pylab.text(x[0],y[0],samp)

    pylab.show()


def distance3(distance, a1, a2, a3):
    """
    Distance between 3 points
    """
    return distance[a1,a2] + distance[a1,a3] + distance[a2,a3]

def distance3Dist(distance, n):
    els = len(distance[0])

    dists = []
    
    """
    # random dist
    r = random.Random(0)
    for i in range(n):
        a = r.sample(range(els),3)
        dists.append(distance3(distance, a[0], a[1], a[2]))
    """

    for i in range(els):
        for j in range(i+1,els):
            for k in range(j+1,els):
                dists.append(distance3(distance, i, j, k))

    print "DLEN", len(dists)

    return dists
        
def pval(dist, v):
    return len([a for a in dist if a <= v])/float(len(dist))

def geneToTerms():

    import go
    go.loadGO() 
    go.loadAnnotation('dictyBase')
    print "Annot loaded"
    terms = [t.id for t in go.loadedGO.terms ]
    
    def cb():
        print "CB"

    print "Find genes"

    #gene -> term
    gt = go.findGenes(GOTerms=terms, reportEvidence=False, directAnnotationOnly=False, progressCallback=cb)
    return gt


def ddiPathways():

    gen1 = {}

    def addSource(dic, addition):
        return dict( \
            [ (addition + name,genes) for name,genes in dic.items() ]\
            )

    # KEGG PATHWAYS

    import obiKEGG
    kegg = obiKEGG.KEGGOrganism("ddi")

    pways = kegg.list_pathways()

    dicp = {}
    for id,desc in pways.items():
        dicp[desc] = kegg.get_genes_by_pathway(id)

    gen1.update(addSource(dicp, "[KEGG] "))

    # GO pathways

    import go
    go.loadGO()
    go.loadAnnotation('dictyBase')
 
    #gt = geneToTerms()
    _,gt = m.autoPickler("geneToTerms.pck", "3", geneToTerms)

    td = go.loadedGO.termDict

    map = {} #map from set id to to it's genes

    print "POS KEYS", len(gt.keys())

    for gene,sets in gt.items():
        for s in sets:
            cs = map.get(s, set())
            cs.add(gene)
            map[s] = cs

    nmap = {}

    def getDDB(l):
        """ spremeni geneDDB v DDB" """
        for a in l:
            try:
                return a[a.index("DDB"):]
            except:
                pass
        return l[0]


    for a,b in map.items():
        #print a, td[a].name, len(b)

        lg = [ getDDB([g] + go.loadedAnnotation.geneNamesDict[g]) \
            for g in list(b) ]

        nmap[td[a].name] = lg


    #test for gene names

    genenames = list(set(reduce(lambda x,y: x+y, [list(a) for a in map.values()])))

    allaliases = [ go.loadedAnnotation.geneNamesDict[name] for name in genenames ]

    genenameswddb = [ getDDB(als) for als in allaliases if getDDB(als) != False ]
    print len(genenameswddb)
    genenames = genenameswddb

    #print genenames[:100]

    print "SEARCH KEGG", "all", len(genenames) ,"notin", searchKEGG(genenames)
    
    gen1.update(addSource(nmap, "[GO] "))

    return gen1


def combineReplicates(groups, ll, legend, avg=stats.mean):
    """
    Combines replicates by averaging.
    """
    outll = []
    outlegend = []
    for name,group in groups:
        lls = [ ll[i] for i in group ]
        avgs = [ avg(m.nth(lls, i)) for i in range(len(lls[0])) ]
        outll.append(avgs)
        outlegend.append(("", name))
    return outll, outlegend


def removeAnyUnknownGenes(ll, genes):
    removeInd = set()

    for ex in ll:
        for i,v in enumerate(ex):
            if v == None:
                removeInd.add(i)

    lln = []
    for ex in ll:
        lln.append([ a for i,a in enumerate(ex) if i not in removeInd ])

    genesn = None
    if genes:
        genesn = [ a for i,a in enumerate(genes) if i not in removeInd ]

    return lln, genesn

        

def distanceCals(combineRepl=False, ver=1):
    """
    Calculates distances between mutants, shows it's mds and pvalues 
    of respective groups.
    """

    ets = getBasicDataPck(ver)

    print ets[0].annot

    annotsan = []

    for et in ets:
        annotsan.append([et.annot["sample"], et.annot["replicate"], et.annot["techReplicate"]])

    annotsan.sort()
    for an in annotsan:
        print "%10s %10s %10s" % (an[0][0], ", ".join(an[1]), ", ".join(an[2]))

    aaa = aaaa


    ll,legend,_ = etsToLists(ets)
    print "origlesn", len(ll[0])
    ll,_ = removeAnyUnknownGenes(ll, None)
    print "new len", len(ll[0])

    groups = []
    for a in set(m.nth(legend,1)):
        groups.append((a,[ i for i,e in enumerate(m.nth(legend,1)) if e == a ]))

    if combineRepl:
        ll,legend = combineReplicates(groups, ll, legend)

    distance = pearsonCorr(ll)
    print distance

    """
    P-values of replicate distance - pointless, if replicates are combined
    """
    if not combineRepl:
        #distribution of distances
        distD = sorted(distance3Dist(distance,1000))

        print "Groups", groups
        print "P-values of triplets"
        res = []
        for a,g in groups:
            d = distance3(distance, g[0], g[1], g[2])
            pv = pval(distD, d)
            res.append((a, pv, d))
            print a, pv

        max = 1200

        starth = max/10.
        h = starth
        for a,pv,d in sorted(res,lambda x,y: cmp(x[2],y[2])):
            pylab.plot([d,d],[0,max])
            pylab.text(d,h,a)
            pylab.text(d,h-max/25.,"p="+ ("%0.3f" % pv))
            h+=(0.9/len(groups)*2)*max
            if h > 0.9*max:
                h = starth

        pylab.hist(distD,100,fc="#888888", ec="#888888")
        pylab.show()

    mdsruns = 1000
    mds = MDS(distance, runs=mdsruns)

    print legend

    points = [] 
    for i,d in enumerate(legend): 
        points.append((mds.points[i][0], mds.points[i][1], d[1])) 
 
    replicatesGraph(points)

    denl =[ a[1]+a[0] for a in legend ]

    hclust(distance, labels=denl, width=300)

    #pylab.savefig('mds-fisrts_r_%d.png' % mdsruns, dpi=72)


def hclust(distance, labels, fn="test.png", **kwargs):

    #are labels a clustering bug? - TODO ask ales

    clus = orange.HierarchicalClustering(distance, linkage=orange.HierarchicalClustering.Average) 
    print "labels", labels
    print printClustering(clus)

    import orngClustering

    clus1 = orngClustering.DendrogramPlot(clus, labels=labels, **kwargs)
    clus1.Plot(fn)

    distance.objects = labels
    clus = orange.HierarchicalClustering(distance, linkage=orange.HierarchicalClustering.Average) 
    print printClustering(clus)


def searchKEGG(genenames):
    """
    Analyses how are genes represented in kegg database.
    """
    import obiKEGG
    kegg = obiKEGG.KEGGOrganism("ddi")

    listunk = []
    for gene in genenames:
        if isinstance(gene, basestring):
            a,b,c = kegg.get_unique_gene_ids([gene], caseSensitive=False)
        else:
            for g in gene:
                a,b,c = kegg.get_unique_gene_ids([g], caseSensitive=False)
                if len(a) > 0:
                    break

        if len(a) == 0:
            listunk.append(gene)

    print len(listunk), listunk 

def pathwayAnalysis(ver=1):

    ets = getBasicDataPck(ver)
    #ets = getBasicData()

    def names():
        return [ ex["DDB"].native() for ex in ets[0] ]

    genenames = names()

    pways = ddiPathways()

    import obiGeneMatch
    gm = obiGeneMatch.GeneMatch(genenames, caseSensitive=False, organism="ddi")

    print "Gene values", len(set(m.flatten(pways.values())))

    gen1 = {}

    for pathw in pways.items():
        matched = gm.match(pathw[1])
        if len(matched) > 3:
            print pathw[0], matched, len(matched), len(pathw[1])
            gen1[pathw[0]] = pathw[1]

    print "NUM", len(gen1)

    m.pck("precompPathways.pck", gen1)
    
def createExampleTable(genes, examples):
    attributes = [ orange.FloatVariable(gene) for gene in genes ]

    classes = sorted(set(m.nth(examples,-1)))
    nclass = orange.EnumVariable("type", values=classes)

    domain = orange.Domain(attributes, nclass)


    def convNone(a):
        if a == None:
            return "?"
        else:
            return a


    examplesn = []
    for ex in examples:
        examplesn.append([ convNone(v) for v in ex ])

    data = orange.ExampleTable(domain, examplesn)
    return data

def prepareGseaTable(ver=1):

    ets = getBasicDataSeparatedPck(ver=ver)

    ll,legend,genes = etsToLists(ets, neednatts=1)

    print "ETSLEN", len(ets)
    print "LEGENDLEN", len(legend), len(ll)

    def legToClass(s, t):
        #here the sample can be transfered
        return s + "+" + ("%0.2d" % int(t))

    def convNone(a):
        if a == None:
            return "?"
        else:
            return a

    examples = []
    for vals,leg in zip(ll,legend):
        nvals = [ convNone(a) for a in vals ]
        examples.append(nvals + [ legToClass(leg[1],leg[2]) ] )
    
    data = createExampleTable(genes, examples)

    return data

def printFigure(fig, filename):
    canvas = FigureCanvasAgg(fig)
    canvas.print_figure(filename, dpi=160)

def drawHist(x,filename="out.png"):
    """
    fig = Figure(figsize=(6,4))
    ax = fig.add_subplot(1,1,1)
    ax.set_title("title")
    ax.set_xscale('log')
    ax.set_yscale('log')
    """

    import pylab

    pylab.hist(x,100)
    pylab.show()

def analyseVariation(ver=1):

    ets = getBasicDataPck(ver)
    ll,legend,genes = etsToLists(ets)

    import stats

    def ltf(l,d=0):
        """
        Converts list to float
        """
        out = []
        for a in l:
            try:
                out.append(float(a))
            except:
                pass
                #out.append(d)
        return out

    print [ len(a) for a in ll ]

    #ll = ll[10:20]

    #first take all mutants!
    vars = [ stats.var(ltf(m.nth(ll, a))) for a in range(len(ll[0])) ]

    print vars

    drawHist(vars,"temp.png")
    
def unpckGS(filename):
    import pickle
    f = open(filename,'rb')
    return pickle.load(f)


def getGseaResults(permut=100, ver=1):

    import obiGsea

    data = prepareGseaTable(ver=ver)
    #data.save("abc_v%d.tab" % ver)

    classVals = [ str(val) for val in data.domain.classVar.values ]

    #join all times together
    jvm = {}

    for cv in classVals:
        a,b = cv.split("+")
        classes = jvm.get(a, set())
        classes.add(cv)
        jvm[a] = classes
    
    jclassesf = [ (mut,list(a)) for mut,a in jvm.items() ]
    print jclassesf
    jclasses = m.nth(jclassesf, 1)

    gen1 = unpckGS("precompPathways.pck")

    out = [] # first mutant, second mutant, result

    for i in range(len(jclasses)-1):
        for j in range(i+1, len(jclasses)):
            print jclasses[i], jclasses[j]
            res2 = obiGsea.runGSEA(data, n=permut, classValues=[jclasses[i],jclasses[j]], organism="ddi", geneSets=gen1, atLeast=3, minPart=0.05)
            out.append((jclassesf[i][0], jclassesf[j][0], res2))

    return out

def gseaSimilarity(ver=1):

    if ver == 1:
        gs = m.autoPck("gsearf1000.pck", "1", getGseaResults, permut=1000, ver=ver)
    if ver == 2:
        gs = m.autoPck("gsearf100_v2.pck", "5", getGseaResults, permut=100, ver=ver)


    allMutants = sorted(set(m.nth(gs,0) + m.nth(gs,1)))
    print allMutants

    mid = dict([ (e,i) for i,e in enumerate(allMutants) ])

    mat = orange.SymMatrix(len(allMutants))

    def signifGenesets(m1,m2,res):
        res = sorted(res.items(), lambda x,y: cmp(x[1][2], y[1][2]))
        return len([ a for a,b in res if b[2] < 0.05 ])

    def newGenes(genes, genesets):
        for g in genesets:
            gen1 = set(g)
            gen2 = set(genes)
            dist = float(len(gen1 & gen2)) / len(gen1 | gen2)
            if dist > 0.8:
                return False
        return True


    def signifGenesets2(m1,m2,res):
        """
        Disregard similar similar genesets.
        """

        res = sorted(res.items(), lambda x,y: cmp(x[1][2], y[1][2]))
        genesets = []
        ql = []

        for a,b in res:
            if b[2] < 0.05:
                if newGenes(b[6], genesets):
                    ql.append(a)
                    genesets.append(b[6])
        return len(ql)

    def signifGenesets3(m1,m2,res):
        """
        Disregard similar similar genesets. Till a certain sum is
        reached.
        """

        res = sorted(res.items(), lambda x,y: cmp(x[1][2], y[1][2]))
        genesets = []
        ql = []

        print "NEW"
        sum = 0.0
        for a,b in res:
            if newGenes(b[6], genesets):
                if sum + b[2] >= 0.10:
                    break
                ql.append(a)
                genesets.append(b[6])
 
                sum += b[2]
                print sum

        return len(ql)

    for m1,m2,res in gs:
        mat[mid[m1],mid[m2]] = signifGenesets2(m1,m2,res)
 
    return mat, allMutants, mid

def MDSGseaSimilarity(ver=1, connect=False):

    mat, allMutants, mid = gseaSimilarity(ver=ver)

    mds = MDS(mat)

    points = []
    import pylab
    for i,d in enumerate(allMutants):
        points.append((mds.points[i][0], mds.points[i][1], d))

    if connect:
        #connect near points
        for i in range(len(mid)-1):
            for j in range(i+1, len(mid)):
                if mat[i,j] <= 1:
                    pylab.plot([mds.points[i][0],mds.points[j][0]], \
                    [mds.points[i][1],mds.points[j][1]])

    replicatesGraph(points)
    clusterGseaSimilarity(ver=ver)

def clusterGseaSimilarity(ver=1):
    mat, allMutants, mid = gseaSimilarity(ver=ver)
    hclust(mat, labels=allMutants, width=300)
    mat.objects = allMutants
    clus = orange.HierarchicalClustering(mat, linkage=orange.HierarchicalClustering.Average) 
    print printClustering(clus)

"""
Try building classifiers.
"""

def tryClassifiers(ver=1):
    ets = getBasicDataPck(ver=ver)
   
    ll,legend,genes = etsToLists(ets)
    
    #print len(ll[0])
    #print len(genes)
 
    genes = genes

    legend = [ a[1] for a in legend ]

    examples = []
    for a,l in zip(ll, legend):
        examples.append(a + [l])

    data = createExampleTable(genes, examples)
    data.save("tet.tab")

    print sorted(set(legend))
    
    def testSet(close):
        others = list(set(legend) - set(close))

        dataS = mOrngData.joinCV(data, [ close, others ], joiner="+")

        import orngTest, orngStat, orngEnsemble

        rfl = orngEnsemble.RandomForestLearner(trees=100)
        learners = [ rfl ]

        res = orngTest.leaveOneOut(learners, dataS)
        return orngStat.AUC(res) 


    #((((ABC-B4-abcG16-)abcA5-)(((abcC3-abcG15-)abcG2-)abcG5-))(abcA2-abcB5-))   

    #((((ABC-B4-abcG16-)(abcB5-abcG6-))((((((abcA2-abcA5-)abcF2-)(abcC3-abcE1-))abcG24-)(abcG15-abcG2-))abcG5-))(abcG20-pkaR-))

    closesets = [ [ 'abcC3-', 'abcG15-', 'abcG2-' ], \
        [ "abcC3-","abcG15-","abcG2-","abcG5-" ], \
        [ "ABC-B4-","abcG16-" ], [ "abcA2-", "abcB5-" ] ]

    closesets2 = [ [ "ABC-B4-", "abcG16-"], 
                [ "abcA2-","abcA5-","abcF2-" ],
                [ "abcA2-", "abcA5-", "abcF2-", "abcC3-", "abcE1-" ],
                [ "ABC-B4-", "abcG16-", "abcB5-", "abcG6-" ],
                [ "abcA2-", "abcA5-", "abcF2-", "abcC3-", "abcE1-", "abcG24-", "abcG15-", "abcG2-", ],
                [ "abcA2-", "abcA5-", "abcF2-", "abcC3-", "abcE1-", "abcG24-", "abcG15-", "abcG2-", "abcG5-" ] ]
                
    closesets3 = [ [a] for a in sorted(set(legend)) ]

    if ver == 2:
        closesets = closesets + closesets2 + closesets3

    print closesets

    def calcRandDist(rep, ln):
        return [ 1.0 ] #when not needed
        resrnd = []
        for i in range(rep):
            nset = rnd.sample(sorted(set(legend)), ln)
            resrnd.append(testSet(nset)[0])
        return resrnd

    lmap = {}
    def getRandDist(rep, ln):
        if (rep,ln) in lmap:
            return lmap[(rep,ln)]
        else:
            rd = calcRandDist(rep, ln)
            lmap[(rep,ln)] = rd
            return rd

    for closeset in closesets:
        rescs =  testSet(closeset)[0]

        print closeset
        print rescs

        rnd = random.Random(0)
        resrnd = getRandDist(100, len(closeset))

        #print sorted(resrnd), same
        print closeset, "AUC = ", rescs ,"pval = ", len([a for a in resrnd if a >= rescs])/float(len(resrnd))


def printClustering(cluster):
    if cluster.branches: 
        return "(%s%s)" % (printClustering(cluster.left), printClustering(cluster.right)) 
    else: 
        return cluster[0]


if __name__=="__main__":

    #data = prepareGseaTable(ver=2)
    #data.save("abc_v2.1.tab")

    import optparse
    p = optparse.OptionParser()
    p.add_option("--distances", action="store_true", 
        help="Analysis of distances between mutant replicates.")
    p.add_option("--distancesJoined", action="store_true",
        help="Analysis of distances between mutants (replicates joined).")
    p.add_option("--gseaSim", action="store_true",
        help="Cluster by GSEA similarity.")
    p.add_option("--pathwayAnalysis", action="store_true",
        help="Analysis of DDB in kegg and build of genesetes from GO and KEGG")
    p.add_option("--variation", action="store_true",
        help="Analysis of variation in genes")
    p.add_option("--tryClassifiers", action="store_true")
    p.add_option("--v2", action="store_true",
        help="Bigger table")

    (opts, args) = p.parse_args()
    ver = 1
    if opts.v2:
        ver = 2
    
    if opts.distances: distanceCals(ver=ver)
    elif opts.distancesJoined: distanceCals(combineRepl=True, ver=ver)
    elif opts.tryClassifiers: tryClassifiers(ver=ver)
    elif opts.gseaSim: MDSGseaSimilarity(ver=ver)
    elif opts.pathwayAnalysis: pathwayAnalysis(ver=ver)
    elif opts.variation: analyseVariation(ver=ver)

    #pathwayAnalysis()
    #prepareGseaTable()
    #analyseVariation()
    #gseaSimilarity()
    #distanceCals()
    #tryClassifiers()
    #clusterGseaSimilarity()

    
       



    
    






