import orange

def printData(data):
    for ex in data:
        print ex

def impute(data):
    imputer = orange.ImputerConstructor_model()
    imputer.learnerContinuous = imputer.learnerDiscrete = orange.MajorityLearner()
    imputer = imputer(data)
    return imputer(data)
    
import random

class PearsonDistance(orange.ExamplesDistance):

    def __init__(self, examples):
        self.data = examples
        self.newdom = None
        imputer = orange.ImputerConstructor_model()
        imputer.learnerContinuous = imputer.learnerDiscrete = orange.MajorityLearner()
        
        attrs = range(len(examples.domain.attributes))
        uv = [ len([ ex[ati].value for ex in examples if ex[ati].value == "?" ]) for ati in attrs ]
        takeattrs = [ examples.domain.attributes[i] for i,a in enumerate(uv) if a != len(examples) ]
        if len(takeattrs) != len(uv):
            self.newdom = orange.Domain(takeattrs, examples.domain.classVar)
            self.data = orange.ExampleTable(self.newdom, self.data)

        self.imputer = imputer(self.data)


    def __call__(self, a1, a2):
        
        if self.newdom:
            a1 = orange.Example(self.newdom, a1)
            a2 = orange.Example(self.newdom, a2)

        attrs = range(len(a1.domain.attributes))

        a1 = self.imputer(a1)
        a2 = self.imputer(a2)

        v1 = [ a1[i].value for i in attrs ]
        v2 = [ a2[i].value for i in attrs ]

        print v1
        print v2

        import numpy
        cc =  numpy.corrcoef([v1, v2])[0,1]
        print "corr", cc
        return abs(cc)

def PearsonDistanceConstructor(examples, *args, **kwargs):
    return PearsonDistance(examples)

if __name__ == "__main__":
    data = orange.ExampleTable('../iris.tab')
    #take first 100 examples
    data = orange.ExampleTable(data.domain, data[:100]) 

    for i in range(79) + range(80,100):
        data[i][3] = "?"

    printData(data)
    #printData(impute(data))

    knn = orange.kNNLearner(k=10, distanceConstructor=orange.ExamplesDistanceConstructor_Hamming() )

    #data = impute(data)

    print "distances"

    import time
    t = time.time()

    for rep in range(200):

        knn = orange.kNNLearner(k=10, distanceConstructor=PearsonDistanceConstructor)
        knnc = knn(data)

        for i in range(3):
            aaaa = knnc(data[i])

    print "TIME", time.time() - t
